//	               
//	
// AUTHOR: Oleg Butrin. e-mail: obutrin@indesign.rudtp.ru
// 
var langAlertNoDoc = localize({en: "No documents are open!", ru: "  !"});

iniScriptName = "Random Pictures Re-Placer";
iniScriptVersion = "1.0";
iniDefaultFolder = "";
iniFileTypes = "*.tif, *.jpg, *.psd, *.gif, *.eps, *.ps, *.pdf";
iniReplaceLocked = false;
iniReplaceMaster = false;
iniReplacePasteBoard = false;
iniNoDouble = true;
iniFitting = FitOptions.contentToFrame;

function getParent (myObject, myType) {
	while (myObject.constructor.name != "Application") {
		if (myObject.constructor.name == myType) {
			return myObject;
		} else {
			myObject = myObject.parent;
		}
	}
	return null;
}

function getFilesAnyTypes (myTypes) {
	try {
		var myResult = new Array;
		myTypes = myTypes.replace(" ", "", "g");
		var myFileTypes = myTypes.split(",");
		for (var typeCounter = 0; typeCounter < myFileTypes.length; typeCounter++) {
			myResult = myResult.concat(this.getFiles(myFileTypes[typeCounter]))
		}
		return myResult;
	} catch (error) {
		return null;
	}
}
Folder.prototype.getFilesAnyTypes = getFilesAnyTypes;

function getObjects (myDoc) {
	try {
		var myResult = new Array;
		for (var pictCounter = 0; pictCounter < myDoc.allGraphics.length; pictCounter++) {
			var myPicture = myDoc.allGraphics[pictCounter];
			var myPage = getParent(myPicture, "Page");
			if ((myPage == null) && (!iniReplacePasteBoard)) {
				continue;
			}
			if ((myPage.parent.constructor.name == "MasterSpread") && (!iniReplaceMaster)) {
				continue;
			}
			if ((myPicture.parent.locked) && (!iniReplaceLocked)) {
				continue;
			}
			myResult.push(myPicture.parent);
		}
		return myResult;
	} catch (error) {
		return null;
	}
}

function getRandom (myArray) {
	try {
		var myNumber = Math.random() * myArray.length;
		return Math.round(myNumber);
	} catch (error) {
		return null;
	}
}

with (app) {
	try {
		var myDoc = activeDocument;
	} catch (error) {
		alert(langAlertNoDoc);
		exit();
	}
	if (Folder(iniDefaultFolder).exists) {
		var myStartFolder = iniDefaultFolder;
	} else {
		try {
			var myStartFolder = myDoc.filePath;
		} catch (error) {
			var myStartFolder = Folder.myDocuments;
		}
	}
	var myFolder = Folder().selectDlg(iniScriptName + " " + iniScriptVersion, myStartFolder);
	if (!myFolder) {
		exit();
	}
	var myFiles = myFolder.getFilesAnyTypes(iniFileTypes);
	var myObjects = getObjects(myDoc);
	if (myObjects.length > myFiles.length) {
		iniNoDouble = false;
	}
	for (var objCounter = 0; objCounter < myObjects.length; objCounter++) {
		var myObject = myObjects[objCounter];
		var myNumber = getRandom(myFiles);
		var myFile = myFiles[myNumber];
		if (iniNoDouble) {
			myFiles.splice(myNumber, 1);
		}
		try {
			myObject.place(myFile, false);
			myObject.fit(iniFitting);
		} catch (error) {
			
		}
	}
}